/*!
*  filename: ej.mobile.angular.js
*  version : 12.3
*  Copyright Syncfusion Inc. 2001 - 2014. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
*/

// JavaScript source code
(function ($, ej, wd, ang, undefined) {
    'use strict';
    ej.module.factory('$splitView', ['$window', '$location', function ($window, $location) {
        var jqLite = angular.element;
        var activeHistroy = 0;
        var loadContent = {
            location: function ($scope, $route, hash) {
                var isHigherLevel = $route.routes['/' + angular.lowercase(hash)].data.isHigherLevel;
                if (isHigherLevel) {
                    //path change in touch end event
                    $scope.$evalAsync(function ($scope) {
                        $location.path("/" + angular.lowercase(hash));
                    });
                }
                else {
                    if (activeHistroy != 0)
                        $window.history.go(-(activeHistroy));
                    $scope.$evalAsync(function ($scope) {
                        $location.path("/" + angular.lowercase(hash)).replace();
                    });
                }
            }
        }
        return loadContent;
    }]);
    ej.module.directive("ejRightpane", ["$compile", function ($compile) {
        return {
            restrict: "CAE",
            controller: "$rightPaneController",
            link: function (scope, element, attr, ctrls) {
                ctrls.initPane(element);
                scope.$on("$viewContentLoaded", function (event, Viewconfig) {
                    var self = angular.element(".e-m-splitpane").data("ejmSplitPane");
                    self.refreshRightScroller();
                })
            }
        }
    }]);
    ej.module.controller("$rightPaneController", ["$scope", "$route", "$transitionBack", "$animate", function ($scope, $route, $transitionBack, $animate) {
        var options = $route.current.data;
        this.initPane = function (element) {
            var jqLite = angular.element;
            var pageid = "page_" + parseInt(Math.random().toFixed(3) * 1000);
            var self = angular.element(".e-m-splitpane").data("ejmSplitPane");
            jqLite("body").removeClass("viewport-turn  viewport-slide  viewport-none viewport-pop viewport-flip").addClass("viewport-" + options.transition);
            if (self.model.overlayLeftPane)
                self._hideLeftPaneHandler();
            var fromPage = self.element.find(".e-m-currentpage");
            if (fromPage.length > 0) {
                fromPage.css("display", "none");
            }
            $transitionBack.state($scope, $route, $animate, element, fromPage);
            fromPage.removeClass("e-m-currentpage reverse");
            self._toPage = element.addClass("e-m-currentpage " + options.transition);
            self._view = self._toPage;
            self._currentPage = jqLite(self._toPage.parents("[data-ej-layout]").addClass("e-m-sp-right subpage e-m-" + self.model.renderMode + " e-m-" + self.model.theme));
            self._toPage.addClass("e-m-sp-rightwrapper");
            self._toPage.wrapInner("<div>");
            //Right pane scroll panel implementation
            self._toPage.attr("id", pageid + "_rightscroller");
            if ((self.model.allowRightPaneScrolling && options.allowRightPaneScrolling) || (self.model.allowRightPaneScrolling && self.allowRightPaneScrolling == undefined)) {
                self._rightScroller = jqLite("<div>");
                self.model.rightPaneScrollSettings.target = pageid + "_rightscroller";
                self.model.rightPaneScrollSettings.renderMode = self.model.renderMode;
                self.model.rightPaneScrollSettings.theme = self.model.theme;
                self._toPage.append(self._rightScroller.ejmScrollPanel($.extend(true, self.model.rightPaneScrollSettings, options.rightPaneScrollSettings)));
            }
            //Header implementation on right pane.
            if (self.model.renderMode != "android" && self.model[self.model.renderMode].showRightPaneHeader) {
                if (!self._toPage.find(">div").hasClass("e-m-header")) {
                    if (!self._currentPage.find(".e-m-header").hasClass("e-m-rightpaneheader")) {
                        self._rightHeader = jqLite("<div class='e-m-rightpaneheader'>");
                        self._toPage.before(self._rightHeader);
                    }
                    self.model.rightHeaderSettings.renderMode = self.model.renderMode;
                    self.model.rightHeaderSettings.theme = self.model.theme;
                    self.model.rightHeaderSettings.position = "normal";
                    self.instance = $(self._rightHeader)["ejmHeader"]($.extend(true, self.model.rightHeaderSettings, options.rightHeaderSettings)).data("ejmHeader");
                }
            }
            //Toolbar implementation.
            if (self.model.android.showToolbar && ej.isAndroid() && options.toolbarSettings) {
                if (options.toolbarSettings.android) {
                    self._currentPage.attr({ "data-ej-toolbarsettings-android-title": self._andTB.attr("data-ej-toolbarsettings-android-title"), "data-ej-toolbarsettings-items": self._andTB.attr("data-ej-toolbarsettings-items") });
                    self._andTB.ejmToolbar({ android: { title: options.toolbarSettings.android.title }, items: eval(options.toolbarSettings.items) });
                    self._toPage.attr({ "data-ej-toolbarsettings-android-title": options.toolbarSettings.android.title, "data-ej-toolbarsettings-items": options.toolbarSettings.items });
                }
            }
            fromPage.css("display", "block");
        }
    }]);
    ej.module.service("$transitionBack", ['$location','$window',function ($location, $window) {
        var currentPath, nextPath, forwardPath, backPath;
        var length = 0;
        var prevent = 0;
        this.state = function ($scope, $route, $animate, element, fromPage) {
            if (/ipad/i.test($window.navigator.userAgent.toLowerCase()) || (/safari/i.test($window.navigator.userAgent.toLowerCase()) && /windows/i.test($window.navigator.userAgent.toLowerCase()))) {
                $scope.$on('$locationChangeStart', function (event, next, current) {
                    var nextRoute = $route.routes[$location.path()];
                    if (nextRoute) {
                        if (nextRoute.data.isHigherLevel) {
                            currentPath = current.split('#')[1];
                            nextPath = next.split('#')[1];
                            backPath = nextPath;
                            if (!$route.routes[currentPath].data.isHigherLevel) {
                                forwardPath = currentPath;
                            }
                        }
                    }
                    else if (backPath != undefined) {
                        $location.path(forwardPath).replace();
                    }
                });
            }
            $scope.$on('$routeChangeSuccess', function () {
                var historyLength = $window.history.length;
                if ($route.current.data.transition == "none") {
                    if ((prevent > historyLength - 1) && fromPage.length > 0) {
                        fromPage.addClass("e-m-prevent-transition");
                        prevent = historyLength - 1;
                    }
                    else {
                        element.removeClass("e-m-prevent-transition");
                        fromPage.removeClass("e-m-prevent-transition");
                    }
                }
                else {
                    fromPage.removeClass("e-m-prevent-transition");
                    prevent = historyLength;
                }
                if ($route.current.data.transition != "none") {
                    if ((length > historyLength - 1)) {
                        element.addClass("reverse");
                        fromPage.addClass("reverse");
                        length = historyLength - 1;
                    }
                    else {
                        element.removeClass("reverse");
                        fromPage.removeClass("reverse");
                        length = historyLength;
                    }
                }
                else {
                    length = 0;
                }
            });
        }
    }])

})(window.jQuery, window.Syncfusion, window.Syncfusion.widget, window.angular);;